// dxpad_sample.cpp : R\[ AvP[ṼGg |Cg`܂B
//WCXeBbÑfoCX̃f[^`OLqTvB

#include "stdafx.h"

//
//	R\[Avp
//
#include <windows.h>
#include <conio.h>

//
//	DirectInputp
//
//CũN
#pragma comment(lib,"dinput8.lib")
#pragma comment(lib,"dxguid.lib")

//DirectInput
#define DIRECTINPUT_VERSION     0x0800          // DirectInput̃o[Ww
#include <dinput.h>

// O[oϐ`
HWND hWlg;
LPDIRECTINPUT8			lpDI = NULL;			// IDirectInput8IuWFNg
LPDIRECTINPUTDEVICE8    lpJoystick = NULL;      // WCXeBbNfoCX

//eXg
GUID testguid;

//	R\[
int Locate(HANDLE, int, int);
int TxtPrint(HANDLE, char *);
HWND GetConsoleHwnd(void);
//	DirectInput
BOOL PASCAL EnumJoyDeviceProc( LPCDIDEVICEINSTANCE ,LPVOID );

///////////////////////////////////////////////////////////
//
//	DIJOYSTATE2Ƃ̈Ⴂ
//
//	EDIJOYSTATE3	FWCXeBbN擾\
//	Ec_dfDIJoystick3	FWCXeBbÑf[^`
//

//	WCXeBbN擾\
typedef struct DIJOYSTATE3 {
    LONG    lX;                     /* x-axis position              */
    LONG    lY;                     /* y-axis position              */
    LONG    lZ;                     /* z-axis position              */
    LONG    lRx;                    /* x-axis rotation              */
    LONG    lRy;                    /* y-axis rotation              */
    LONG    lRz;                    /* z-axis rotation              */
    LONG    rglSlider[2];           /* extra axes positions         */
    DWORD   rgdwPOV[4];             /* POV directions               */
    BYTE    rgbButtons[128];        /* 128 buttons                  */
    LONG    lVX;                    /* x-axis velocity              */
    LONG    lVY;                    /* y-axis velocity              */
    LONG    lVZ;                    /* z-axis velocity              */
    LONG    lVRx;                   /* x-axis angular velocity      */
    LONG    lVRy;                   /* y-axis angular velocity      */
    LONG    lVRz;                   /* z-axis angular velocity      */
    LONG    rglVSlider[2];          /* extra axes velocities        */
    LONG    lAX;                    /* x-axis acceleration          */
    LONG    lAY;                    /* y-axis acceleration          */
    LONG    lAZ;                    /* z-axis acceleration          */
    LONG    lARx;                   /* x-axis angular acceleration  */
    LONG    lARy;                   /* y-axis angular acceleration  */
    LONG    lARz;                   /* z-axis angular acceleration  */
    LONG    rglASlider[2];          /* extra axes accelerations     */
    LONG    lFX;                    /* x-axis force                 */
    LONG    lFY;                    /* y-axis force                 */
    LONG    lFZ;                    /* z-axis force                 */
    LONG    lFRx;                   /* x-axis torque                */
    LONG    lFRy;                   /* y-axis torque                */
    LONG    lFRz;                   /* z-axis torque                */
    LONG    rglFSlider[2];          /* extra axes forces            */
} DIJOYSTATE3, *LPDIJOYSTATE3;

//foCX IuWFNg̃f[^`
DIOBJECTDATAFORMAT c_rgodfDIJoystick3[164] =
{
	{ &GUID_XAxis,  FIELD_OFFSET(DIJOYSTATE3, lX),             0x80FFFF00 | DIDFT_AXIS,   DIDOI_ASPECTPOSITION },
	{ &GUID_YAxis,  FIELD_OFFSET(DIJOYSTATE3, lY),             0x80FFFF00 | DIDFT_AXIS,   DIDOI_ASPECTPOSITION },
	{ &GUID_ZAxis,  FIELD_OFFSET(DIJOYSTATE3, lZ),             0x80FFFF00 | DIDFT_AXIS,   DIDOI_ASPECTPOSITION },
	{ &GUID_RxAxis, FIELD_OFFSET(DIJOYSTATE3, lRx),            0x80FFFF00 | DIDFT_AXIS,   DIDOI_ASPECTPOSITION },
	{ &GUID_RyAxis, FIELD_OFFSET(DIJOYSTATE3, lRy),            0x80FFFF00 | DIDFT_AXIS,   DIDOI_ASPECTPOSITION },
	{ &GUID_RzAxis, FIELD_OFFSET(DIJOYSTATE3, lRz),            0x80FFFF00 | DIDFT_AXIS,   DIDOI_ASPECTPOSITION },
	{ &GUID_Slider, FIELD_OFFSET(DIJOYSTATE3, rglSlider[0]),   0x80FFFF00 | DIDFT_AXIS,   DIDOI_ASPECTPOSITION },
	{ &GUID_Slider, FIELD_OFFSET(DIJOYSTATE3, rglSlider[1]),   0x80FFFF00 | DIDFT_AXIS,   DIDOI_ASPECTPOSITION },
	{ &GUID_POV,    FIELD_OFFSET(DIJOYSTATE3, rgdwPOV[0]),     0x80FFFF00 | DIDFT_POV,    0 },
	{ &GUID_POV,    FIELD_OFFSET(DIJOYSTATE3, rgdwPOV[1]),     0x80FFFF00 | DIDFT_POV,    0 },
	{ &GUID_POV,    FIELD_OFFSET(DIJOYSTATE3, rgdwPOV[2]),     0x80FFFF00 | DIDFT_POV,    0 },
	{ &GUID_POV,    FIELD_OFFSET(DIJOYSTATE3, rgdwPOV[3]),     0x80FFFF00 | DIDFT_POV,    0 },
	{ &GUID_XAxis,  FIELD_OFFSET(DIJOYSTATE3, rgbButtons[0]),  0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ &GUID_YAxis,  FIELD_OFFSET(DIJOYSTATE3, rgbButtons[1]),  0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ &GUID_ZAxis,  FIELD_OFFSET(DIJOYSTATE3, rgbButtons[2]),  0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ &GUID_RxAxis, FIELD_OFFSET(DIJOYSTATE3, rgbButtons[3]),  0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ &GUID_RyAxis, FIELD_OFFSET(DIJOYSTATE3, rgbButtons[4]),  0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ &GUID_RzAxis, FIELD_OFFSET(DIJOYSTATE3, rgbButtons[5]),  0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ &GUID_Slider, FIELD_OFFSET(DIJOYSTATE3, rgbButtons[6]),  0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ &GUID_Slider, FIELD_OFFSET(DIJOYSTATE3, rgbButtons[7]),  0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ &GUID_XAxis,  FIELD_OFFSET(DIJOYSTATE3, rgbButtons[8]),  0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ &GUID_YAxis,  FIELD_OFFSET(DIJOYSTATE3, rgbButtons[9]),  0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ &GUID_ZAxis,  FIELD_OFFSET(DIJOYSTATE3, rgbButtons[10]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ &GUID_RxAxis, FIELD_OFFSET(DIJOYSTATE3, rgbButtons[11]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ &GUID_RyAxis, FIELD_OFFSET(DIJOYSTATE3, rgbButtons[12]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ &GUID_RzAxis, FIELD_OFFSET(DIJOYSTATE3, rgbButtons[13]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ &GUID_Slider, FIELD_OFFSET(DIJOYSTATE3, rgbButtons[14]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ &GUID_Slider, FIELD_OFFSET(DIJOYSTATE3, rgbButtons[15]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ &GUID_XAxis,  FIELD_OFFSET(DIJOYSTATE3, rgbButtons[16]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ &GUID_YAxis,  FIELD_OFFSET(DIJOYSTATE3, rgbButtons[17]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ &GUID_ZAxis,  FIELD_OFFSET(DIJOYSTATE3, rgbButtons[18]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ &GUID_RxAxis, FIELD_OFFSET(DIJOYSTATE3, rgbButtons[19]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ &GUID_RyAxis, FIELD_OFFSET(DIJOYSTATE3, rgbButtons[20]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ &GUID_RzAxis, FIELD_OFFSET(DIJOYSTATE3, rgbButtons[21]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ &GUID_Slider, FIELD_OFFSET(DIJOYSTATE3, rgbButtons[22]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ &GUID_Slider, FIELD_OFFSET(DIJOYSTATE3, rgbButtons[23]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[24]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[25]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[26]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[27]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[28]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[29]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[30]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[31]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[32]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[33]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[34]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[35]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[36]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[37]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[38]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[39]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[40]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[41]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[42]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[43]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[44]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[45]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[46]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[47]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[48]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[49]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[50]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[51]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[52]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[53]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[54]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[55]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_BUTTON, 0 },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_AXIS,   DIDOI_ASPECTVELOCITY },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_AXIS,   DIDOI_ASPECTVELOCITY },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_AXIS,   DIDOI_ASPECTVELOCITY },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_AXIS,   DIDOI_ASPECTVELOCITY },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_AXIS,   DIDOI_ASPECTVELOCITY },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_AXIS,   DIDOI_ASPECTVELOCITY },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rglSlider[0]),   0x80FFFF00 | DIDFT_AXIS,   DIDOI_ASPECTVELOCITY },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rglSlider[1]),   0x80FFFF00 | DIDFT_AXIS,   DIDOI_ASPECTVELOCITY },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_AXIS,   DIDOI_ASPECTACCEL },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_AXIS,   DIDOI_ASPECTACCEL },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_AXIS,   DIDOI_ASPECTACCEL },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_AXIS,   DIDOI_ASPECTACCEL },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_AXIS,   DIDOI_ASPECTACCEL },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_AXIS,   DIDOI_ASPECTACCEL },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rglSlider[0]),   0x80FFFF00 | DIDFT_AXIS,   DIDOI_ASPECTACCEL },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rglSlider[1]),   0x80FFFF00 | DIDFT_AXIS,   DIDOI_ASPECTACCEL },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_AXIS,   DIDOI_ASPECTFORCE },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_AXIS,   DIDOI_ASPECTFORCE },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_AXIS,   DIDOI_ASPECTFORCE },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_AXIS,   DIDOI_ASPECTFORCE },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_AXIS,   DIDOI_ASPECTFORCE },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rgbButtons[56]), 0x80FFFF00 | DIDFT_AXIS,   DIDOI_ASPECTFORCE },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rglSlider[0]),   0x80FFFF00 | DIDFT_AXIS,   DIDOI_ASPECTFORCE },
	{ NULL,         FIELD_OFFSET(DIJOYSTATE3, rglSlider[1]),   0x80FFFF00 | DIDFT_AXIS,   DIDOI_ASPECTFORCE }
};
//	foCX̃f[^`
DIDATAFORMAT c_dfDIJoystick3 =
{
	sizeof(DIDATAFORMAT),
	sizeof(DIOBJECTDATAFORMAT),
	DIDF_ABSAXIS,
	sizeof(DIJOYSTATE3),
	(sizeof(c_rgodfDIJoystick3) / sizeof(DIOBJECTDATAFORMAT)),
	c_rgodfDIJoystick3
};



//
//	DIJOYSTATE2Ƃ̈Ⴂ܂
//
///////////////////////////////////////////////////////////


//	C
int _tmain(int argc, _TCHAR* argv[])
{

	//
	//	DirectInput
	//

	//AṽCX^X
	HINSTANCE hInstance = GetModuleHandle(NULL);

	//R\[AṽEChEnh擾
	hWlg = GetConsoleHwnd();

    // IDirectInput8̍쐬
    HRESULT ret = DirectInput8Create( hInstance,DIRECTINPUT_VERSION,IID_IDirectInput8,(LPVOID*)&lpDI,NULL );
	if( FAILED(ret) ) {
		// 쐬Ɏs
		return -1;
	}

    // WCXeBbN̗
    ret = lpDI->EnumDevices( DI8DEVCLASS_GAMECTRL,EnumJoyDeviceProc,NULL,DIEDFL_ATTACHEDONLY );
    if( FAILED(ret) ) {
        lpDI->Release();
        return -1;
    }
	//WCXeBbN̗LmF
    if( !lpJoystick ) {
        // WCXeBbNPȂ
        lpDI->Release();
        return -1;
    }

	// Jn
	lpJoystick->Acquire();
	lpJoystick->Poll();		// |[O

	DIJOYSTATE3 GamePadState; // Q[pbh̏Ԃi[\̕ϐ

	//
	//	\̏
	//
	HANDLE hStdout;
	SYSTEMTIME st;		//\p
	hStdout = GetStdHandle(STD_OUTPUT_HANDLE);	//Wo̓nh擾
	int i, j;

	//
	//	C[v
	//
    while(!_kbhit()) {

		//ݎ\
		//	ƓĂ邱ƂmF邽߁AԂ\܂B@
        Locate(hStdout, 80-16, 0);	//J[\ړ
        GetLocalTime(&st);
		printf("time = %2d:%2d:%2d\r\n", st.wHour, st.wMinute, st.wSecond);


        Locate(hStdout, 0, 3);	//J[\ړ
		for (i = 0; i < 10; i++) {	//ʂ̏
			printf("                                                                               \n");
		}
        Locate(hStdout, 0, 3);	//J[\ړ
		// L[̓
		ret = lpJoystick->GetDeviceState( sizeof(GamePadState), &GamePadState );
		if( FAILED(ret) ) {
			// sȂĊJĂx擾
			lpJoystick->Acquire();
			lpJoystick->Poll();		// |[O
			lpJoystick->GetDeviceState( sizeof(GamePadState), &GamePadState );
			printf("擾sI\n");
		}

		// Q[pbh̏Ԃ𒲂ׂ
		printf("lXYZ :%5d, %5d, %5d\n", GamePadState.lX, GamePadState.lY, GamePadState.lZ);
		printf("lRxyz:%5d, %5d, %5d\n", GamePadState.lRx, GamePadState.lRy, GamePadState.lRz);
		printf("rglSlider:%d, %d\n", GamePadState.rglSlider[0], GamePadState.rglSlider[1]);
		printf("rgdwPOV:%5d, %d, %8d, %8d\n", GamePadState.rgdwPOV[0], GamePadState.rgdwPOV[1], GamePadState.rgdwPOV[2], GamePadState.rgdwPOV[3]);
		printf("lVXYZ :%5d, %5d, %5d\n", GamePadState.lVX, GamePadState.lVY, GamePadState.lVZ);
		printf("lVRxyz:%5d, %5d, %5d\n", GamePadState.lVRx, GamePadState.lVRy, GamePadState.lVRz);
		printf("rglVSlider:%d, %d\n", GamePadState.rglVSlider[0], GamePadState.rglVSlider[1]);
		printf("lAXYZ :%5d, %5d, %5d\n", GamePadState.lAX, GamePadState.lAY, GamePadState.lAZ);
		printf("lARxyz:%5d, %5d, %5d\n", GamePadState.lARx, GamePadState.lARy, GamePadState.lARz);
		printf("rglASlider:%d, %d\n", GamePadState.rglASlider[0], GamePadState.rglASlider[1]);
		printf("lFXYZ :%5d, %5d, %5d\n", GamePadState.lFX, GamePadState.lFY, GamePadState.lFZ);
		printf("lFRxyz:%5d, %5d, %5d\n", GamePadState.lFRx, GamePadState.lFRy, GamePadState.lFRz);
		printf("rglFSlider:%d, %d\n", GamePadState.rglFSlider[0], GamePadState.rglFSlider[1]);

		for (i=0; i < 128; i++) {
			if(0 != (GamePadState.rgbButtons[i] & 0x80)) {
				j = 1;
			} else {
				j = 0;
			}
			printf("%d ", j);
		}
		printf("\n");

		// ͔͈͂̃Zbg
		HRESULT hResult;
		DWORD wVendorID;
		DWORD wProductID;
		DIPROPDWORD pvid;
		pvid.diph.dwSize = sizeof(DIPROPDWORD );
		pvid.diph.dwHeaderSize = sizeof(DIPROPHEADER );
		pvid.diph.dwObj = 0;
		pvid.diph.dwHow = DIPH_DEVICE;
		hResult = lpJoystick->GetProperty( DIPROP_VIDPID,&pvid.diph );
		if (hResult == DI_OK)
		{
			wVendorID  = LOWORD(pvid.dwData);
			wProductID = HIWORD(pvid.dwData);
			printf("VID=0x%04X, PID=0x%04X\n", wVendorID, wProductID);
		} else {
			printf("vid,pid擾sB\n");
		}





		//GUID̕\
        printf("{%08X-%04X-%04X-%02X%02X-%02X%02X%02X%02X%02X%02X}\n",
               testguid.Data1,
               testguid.Data2,
               testguid.Data3,
               testguid.Data4[0], testguid.Data4[1], testguid.Data4[2], testguid.Data4[3],
               testguid.Data4[4], testguid.Data4[5], testguid.Data4[6], testguid.Data4[7]);
/*		char name[256]="testguid";
		printf
            ("#define %s_CLASS_GUID\n{ 0x%08x, 0x%04x, 0x%04x, { 0x%02x, 0x%02x, 0x%02x, 0x%02x, 0x%02x, 0x%02x, 0x%02x, 0x%02x } }\n",
             name, testguid.Data1, testguid.Data2, testguid.Data3, testguid.Data4[0],
             testguid.Data4[1], testguid.Data4[2], testguid.Data4[3], testguid.Data4[4],
             testguid.Data4[5], testguid.Data4[6], testguid.Data4[7]);
*/
		Sleep(15);
	}


	//
	//	DirectInputI
	//
	//	foCX̊J
	lpJoystick->Release();
	lpDI->Release();

	//fobOp
	printf("ɏI܂B\n");
	Sleep(1000);

	return 0;
}

//J[\ړ
int Locate(HANDLE hOut, int x, int y)
{
    COORD dwPos;
    dwPos.X = (SHORT)x;
    dwPos.Y = (SHORT)y;

    if (SetConsoleCursorPosition(hOut, dwPos) == 0)
        return -1;
    else
        return 0;
}


//eLXg\
int TxtPrint(HANDLE hOut, char *str)
{
    BOOL bResult;
    DWORD dwResult;

    bResult = WriteConsole(hOut, (CONST VOID *)str, (DWORD)lstrlen((LPCTSTR)str), &dwResult, NULL);
    if (bResult == 0)
        return -1;
    else
        return 0;
}


//R\[AṽEChEnh擾
HWND GetConsoleHwnd(void)
{
    #define MY_BUFSIZE 1024 // R\[ EBhẼ^Cgp̃obt@TCY
    HWND hwndFound;         // Ăяo֕Ԃl
    char pszNewWindowTitle[MY_BUFSIZE];
                           // 쐬EBhẼ^Cg܂
    char pszOldWindowTitle[MY_BUFSIZE]; // ̃EBhE^Cg܂

    // ݂̃EBhE^Cg擾܂

    GetConsoleTitle(pszOldWindowTitle, MY_BUFSIZE);

    // ƎɁAEBhE̐VK^CgtH[}bg܂

    wsprintf(pszNewWindowTitle,"%d/%d",
             GetTickCount(),
             GetCurrentProcessId());

    // ݂̃EBhE^CgύX܂

    SetConsoleTitle(pszNewWindowTitle);

    // EBhE^Cg̃Abvf[gmȂ̂ɂ܂

    Sleep(40);

    // EBhE̐VK^CgTɂ܂

    hwndFound=FindWindow(NULL, pszNewWindowTitle);

    // ̃EBhE^Cg֖߂܂

    SetConsoleTitle(pszOldWindowTitle);

    return(hwndFound);
}




//foCX񋓊֐
BOOL PASCAL EnumJoyDeviceProc( LPCDIDEVICEINSTANCE lpddi,LPVOID pvRef )
{

    // WCXeBbNfoCX̍쐬
    HRESULT ret = lpDI->CreateDevice( lpddi->guidInstance,&lpJoystick,NULL );
    if( FAILED(ret) ) {
        printf( "foCX쐬s\n" );
        return DIENUM_STOP;
    }
	testguid = lpddi->guidInstance;

    // ̓f[^`̃Zbg
    ret = lpJoystick->SetDataFormat( &c_dfDIJoystick3 );
    if( FAILED(ret) ) {
        printf( "̓f[^`̃Zbgs\n" );
        lpJoystick->Release();
        return DIENUM_STOP;
    }

	hWlg = GetConsoleHwnd();
/*
    // r̃Zbg
    ret = lpJoystick->SetCooperativeLevel( hWlg.hWnd,DISCL_FOREGROUND|DISCL_NONEXCLUSIVE|DISCL_NOWINKEY );
    if( FAILED(ret) ) {
        DEBUG( "r̃Zbgs\n","" );
        lpJoystick->Release();
        return DIENUM_STOP;
    }
*/

    // N
    lpJoystick->Poll();

    // \zȂ
    printf( "CX^X̓o^ [%s]\n",lpddi->tszInstanceName );
    printf( "i̓o^         [%s]\n",lpddi->tszProductName );
    printf( "\z\n","" );
/*
	printf( "guidInstance [0x%x]\n",lpddi->guidInstance.Data1 );
	printf( "guidInstance [0x%x]\n",lpddi->guidInstance.Data2 );
	printf( "guidInstance [0x%x]\n",lpddi->guidInstance.Data3 );
	printf( "guidInstance [0x%x]\n",lpddi->guidInstance.Data4 );
	printf( "guidProduct  [0x%x]\n",lpddi->guidProduct.Data1 );
	printf( "guidProduct  [0x%x]\n",lpddi->guidProduct.Data2 );
	printf( "guidProduct  [0x%x]\n",lpddi->guidProduct.Data3 );
	printf( "guidProduct  [0x%x]\n",lpddi->guidProduct.Data4 );
*/

    // ŏ̂P݂̂ŏI
    return DIENUM_STOP;                     // ̃foCX񋓂ɂDIENUM_CONTINUEԂ
}





